/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Ballonschiessen.
    
    Lmmerlinge is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
	    
    Edelsteine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
	    
    You should have received a copy of the GNU General Public License
    along with Edelsteine; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************************/

#include "config.h"     // ein paar Konstanten
#include "window.h"     // Hauptfenster Darstellung
#include "gamelib.h"    // 
#include "wiese.h"      // Spielwiese
#include <qpopupmenu.h>
#include <qapplication.h>      // Fensterhandling-Event-Routinen
#include <qmenubar.h>          // Menuleiste
#include <qmenudata.h>         // Menu-Items
#include <qaccel.h>            // Shortcuts
#include <qradiobutton.h>      // Auswahl
#include <qbuttongroup.h>      // Auswahl
#include <qfile.h>             // INI-Datei auswerten
#include <stdio.h>             // debugging



// -------------------------------------------------------------------------------------------------------

int main(int argc, char **argv)
{ 
  QApplication my_app(argc,argv);                  // die Fenster/Appli-Steuerung
  window*      my_window    =new window();         // eine Instanz des zu zeigenden Spiel-Hauptfensters
  hiscore*     my_hiscore   =new hiscore();        // Bestenlisten-Hauptfenster
  textviewer*  my_textviewer=new textviewer();     // Fenster fuer Hilfstexte
  wiese*       my_wiese     =new wiese(my_window); // spezifisch fuer Spiel: Wiese und Bewohner
  viewport*    my_view      =my_window->my_view;   // Darstellungsbereich des Spiels
  int i,x,y,z;
    
// --- allgemeines Spielemenu: -----------------------------------------------------------------------------------------      
// erzeugen:
  QMenuBar*   my_menubar=new QMenuBar(my_window);  // Menubar mit Window verbinden    
  QPopupMenu* my_menu1 = new QPopupMenu;           // 3 Popup-Menus fuer Menubar 
  QPopupMenu* my_menu2 = new QPopupMenu;
  QPopupMenu* my_menu3 = new QPopupMenu;
 
// Menu neu, pause/weiter, Bestenliste/Reset, Quit  
  my_menubar->insertItem(MENU10,my_menu1);         // Menuetitel einsetzen
  my_menu1->insertItem(MENU11,my_wiese,SLOT(neues_spiel()),QKeySequence(KUERZEL11),11);         
  my_menu1->insertItem(MENU12,my_wiese,SLOT(pause()),QKeySequence(KUERZEL12),12);   
  my_menu1->insertSeparator();
  my_menu1->insertItem(MENU14,my_hiscore,SLOT(show_hsc()),QKeySequence(KUERZEL14),14);
  my_menu1->insertItem(LOEHSC,my_hiscore,SLOT(reset_hsc())); 
  my_menu1->insertSeparator();
  my_menu1->insertItem(MENU15,&my_app,SLOT(quit()),QKeySequence(KUERZEL15),15);  // slot quit wird eingeschleppt 
  my_menu1->insertSeparator();

// Userpics:  
  my_menubar->insertItem("User Pix       ",my_menu2);    
  QButtonGroup* my_wig2=new QButtonGroup(1,Qt::Horizontal,"Ballons:",0);
  int anz_upics=0,gelesen;
  QFile fh(QString(INIFILE));
  QString bu0,bu1,buff;
  QRadioButton* wig[16];
  if (fh.open(IO_ReadOnly))
  {   
    do
     { 
      gelesen=fh.readLine(buff,96);
      if (gelesen>4)
      { 
	bu0=buff.section(';',0,0); 
	bu1=buff.section(';',1,1);
	wig[anz_upics]=new QRadioButton(bu0,my_wig2);
	my_wiese->p_userpics[anz_upics]=new QCanvasPixmap(bu1);
	anz_upics++;
      }     
    }     
    while (gelesen>4);
    fh.close();
  }

  z=0; QFile f1(QString(SETFILE)); if (f1.open(IO_ReadOnly)) { gelesen=f1.readLine(buff,96); z=buff.toInt(); f1.close(); }  

  my_wig2->setExclusive(true);
  my_wig2->setButton(z);
  my_menu2->insertItem(my_wig2);
  my_menu2->insertItem(_SAVESETTINGS,my_wiese,SLOT(save_settings()));  
  my_app.connect(my_wig2,SIGNAL(clicked(int)),my_wiese,SLOT(userpic(int)));
  
    
// Info-Menuitem:
  my_menubar->insertItem(MENU30,my_menu3);
  my_menu3->insertItem(MENU31,my_textviewer,SLOT(show_info(int)),QKeySequence(KUERZEL31),31);
  my_menu3->insertItem(MENU32,my_textviewer,SLOT(show_info(int)),QKeySequence(KUERZEL32),32); 
  my_menubar->setItemParameter(32,0);
  my_menubar->setItemParameter(31,1);

// --------------------------------------------------------------------------------------------------------------------
// Canvas fuer Sprites erzeugen, mit Viewport verbinden,
// Wiesen-Sprites belegen und mit Canvas verbinden:

  QCanvas* my_canvas=new QCanvas(XMAX+2*DX,YMAX);
  my_view->setCanvas(my_canvas);    
  my_canvas->setBackgroundColor(BACKGR1);
  my_canvas->setBackgroundPixmap(QPixmap(BACKPIX1));
  my_canvas->setDoubleBuffering(true);
  my_canvas->setAdvancePeriod(20);

  my_wiese->my_zielarray  =new QCanvasPixmapArray(ZIELPICS,NUMTYPEN);
  my_wiese->my_ballonarray=new QCanvasPixmapArray(BALLONPICS,NUMTYPEN);
  my_wiese->my_tropfenarray=new QCanvasPixmapArray(TROPFENPICS,NUMTYPEN);

  for (i=0; i<NUMTYPEN; i++)  my_wiese->my_ballonarray->setImage(NUMTYPEN+i,my_wiese->my_tropfenarray->image(i)); 
  for (i=0; i<anz_upics; i++) my_wiese->my_ballonarray->setImage(2*NUMTYPEN+i,my_wiese->p_userpics[i]);   

  my_wiese->my_vgarray    =new QCanvasPixmapArray(VGPIC);
  my_wiese->my_goverarray =new QCanvasPixmapArray(GAMEOVERPIC);
  my_wiese->my_pausearray =new QCanvasPixmapArray(PAUSEPIC);
  my_wiese->my_cursorarray =new QCanvasPixmapArray(CURSORPIC);

  // Check auf Vollstaendigkeit der Bilder:
  QString err="";
  if (!my_wiese->my_zielarray->isValid())   err=err+"Some goal images are missing!\n";
  if (!my_wiese->my_ballonarray->isValid()) err=err+"Some balloons or rags are missing! (Check userpics)\n";
  if (!my_wiese->my_vgarray->isValid())     err=err+"The Foreground image is missing!\n";
  if (!my_wiese->my_goverarray->isValid())  err=err+"Gameover screen is missing!\n";
  if (!my_wiese->my_pausearray->isValid())  err=err+"Pause screen is missing!\n";
  if (!my_wiese->my_cursorarray->isValid()) err=err+"Cursor is missing!\n";
  
  if (err=="")  // Spritebelegung und Initialisierung:
  {  
    my_wiese->p_gover=new QCanvasSprite(my_wiese->my_goverarray,my_canvas);
    my_wiese->p_pause=new QCanvasSprite(my_wiese->my_pausearray,my_canvas);
    my_wiese->p_vg   =new QCanvasSprite(my_wiese->my_vgarray,my_canvas);
    my_wiese->p_cursor   =new QCanvasSprite(my_wiese->my_cursorarray,my_canvas);
    
    my_wiese->p_vg->setZ(30); my_wiese->p_vg->move(OFX,312); my_wiese->p_vg->show(); // Vordergrund
    my_wiese->p_pause->setZ(31); my_wiese->p_pause->move(DX+OFX,160);  // pause zweitoberste Prioritaet
    my_wiese->p_gover->setZ(30); my_wiese->p_gover->move(DX+OFX,160);  // gameover oberste Prioritaet
    my_wiese->p_cursor->setZ(32); my_wiese->p_cursor->move(DX+OFX,160);  
    my_wiese->p_cursor->show();
    
    for (i=0; i<NUMSPRITES; i++)
    { x=i*DX/2+OFX; y=16; 
      my_wiese->my_ballon[i]->p_sprite=new QCanvasSprite(my_wiese->my_ballonarray,my_canvas);
      my_wiese->my_ballon[i]->p_sprite->move(x,y,i%(2*NUMTYPEN));
      my_wiese->my_ballon[i]->p_sprite->setZ(i+2);
      my_wiese->my_ballon[i]->p_sprite->show();
    }
    // Zielpoette:
    for (i=0; i<NUMTYPEN; i++)
    {
      x=96+OFX+i*DX; y=OFY-24;
      my_wiese->p_zielsprite[i]=new QCanvasSprite(my_wiese->my_zielarray,my_canvas);
      my_wiese->p_zielsprite[i]->setZ(1);
      my_wiese->p_zielsprite[i]->move(x,y,i);
      my_wiese->p_zielsprite[i]->show();
    }
   // --- Ende Spritegenerierung -------------------------------------------

    // Game starten:
    my_wiese->userpic(z);
    my_wiese->neues_spiel();
    my_view->setContentsPos(OFX,OFY);
    my_view->polish();
    my_view->show();
  }	    
  else printf(err); // Bilder fehlen


// ---------------------------------------------------------------------------------------------------------------------
  my_app.setMainWidget(my_window);                                                // my_window als Hauptfenster  
  my_app.connect(my_view,SIGNAL(geklickt(int,int)),my_wiese,SLOT(klick(int,int))); // Klick ins Spielfeld, x,y 
  my_app.connect(my_view,SIGNAL(hover(int,int)),my_wiese,SLOT(move_cursor(int,int))); // Klick ins Spielfeld, x,y 
  my_app.connect(my_wiese,SIGNAL(gameover(int)),my_hiscore,SLOT(save_hsc(int)));  // Auswertung Spielende: Punkte
  QPixmap my_pixmap=QPixmap(PROGICON);                                            // Programmicon setzen  
  my_window->setIcon(my_pixmap);
  my_window->show();                      // anzeigen
//  printf("Breite x Hoehe %i x %i\n",my_window->width(),my_window->height());    // Debug-Info
  return my_app.exec();                   // Exec-Schleife der my_app
}
