/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Ballonschiessen which runs under GPL.
*****************************************************************************************/

// Hauptfenster

#include "window.h"

window::window(QWidget *parent,char* name): QHBox(parent,name)
{ 
  //Geometrie und Aussehen: Elemente bei einer QHBox sind spaltenfoermig angelegt:
  this->setMargin(16);
  this->setSpacing(4);
  this->setPaletteBackgroundColor(BACKGR0);
  this->setCaption(TITEL);  
  this->setMaximumSize(WIN_BMAX,WIN_HMAX);
  this->setMinimumSize(WIN_BMIN,WIN_HMIN);

// erste Spalte: Canvasview (Spielfeld)
  QVBox* p_spalte0=new QVBox(this);
  p_spalte0->setSpacing(8);
  my_view=new viewport(p_spalte0,"playfield"); // QCanvasView-Variante
  my_view->show(); 

// zweite Spalte: Titel, darunter Anzeigentafel als 2-spaltiges Gitter:  
  QVBox* p_spalte1=new QVBox(this);
  p_spalte1->setSpacing(8);;
  p_spalte1->setMaximumWidth(208);
  QLabel* p_ue =new QLabel(p_spalte1);
  p_ue->setPixmap(QPixmap(TITELBILD)); 
  QGrid* p_anzeigen=new QGrid(2,p_spalte1,"anzeigen");  // Anzeigetafel
  p_anzeigen->setSpacing(16);
  p_anzeigen->setPaletteBackgroundColor(BACKGR2);
  p_anzeigen->setPaletteBackgroundPixmap(QPixmap(BACKPIX2));
  p_anzeigen->setPaletteForegroundColor(COLOR2);
  p_anzeigen->setMinimumSize(96,96);
  p_anzeigen->setMaximumSize(128,128);

  QPalette my_pal=QPalette(p_anzeigen->palette());  
  my_pal.setColor(QColorGroup::Light,RANDHCOLOR);
  my_pal.setColor(QColorGroup::Dark,RANDDCOLOR);
  p_anzeigen->setPalette(my_pal);

  p_anzeigen->setFrameShadow(Raised);
  p_anzeigen->setFrameShape(Panel);
  p_anzeigen->setMargin(12);

  // Daten einfuellen, ist der Labeltext leer, wird die Anzeige unterdrueckt, dan nicht jedes Spiel alle Anzeigen braucht:  
  if (ANZEIGE0!="") { QLabel* p_llevel =new QLabel(ANZEIGE0,p_anzeigen); p_level  =new QLabel(p_anzeigen); }
  if (ANZEIGE4!="") { QLabel* p_lpfeile=new QLabel(ANZEIGE4,p_anzeigen); p_pfeile =new QLabel(p_anzeigen); }
  if (ANZEIGE3!="") { QLabel* p_lleben =new QLabel(ANZEIGE3,p_anzeigen); p_leben  =new QLabel(p_anzeigen); }
  if (ANZEIGE2!="") { QLabel* p_lzeit  =new QLabel(ANZEIGE2,p_anzeigen); p_zeit   =new QLabel(p_anzeigen); }
  if (ANZEIGE1!="") { QLabel* p_lpunkte=new QLabel(ANZEIGE1,p_anzeigen); p_punkte =new QLabel(p_anzeigen); }
  QLabel* p_nix=new QLabel("",p_anzeigen); QLabel* p_icke=new QLabel("by\n uja",p_anzeigen);
}

// Slots: - nicht benoetigte Slots stoeren erstmal nicht
void window::set_punkte(int p)    { p_punkte->setNum(p); }
void window::set_zeit(int p)      { p_zeit->setNum(p);   }
void window::set_level(QString p) { p_level->setText(p); }
void window::set_leben(int p)     { p_leben->setNum(p);  }
void window::set_pfeile(int p)    { p_pfeile->setNum(p); }
// =================================================================================================================================
